// 001 u_c_customer
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_customer;
  interface
    uses Classes, Db, IbDatabase, IBCustomDataSet;
    
    type c_customer= Class(tIbDataSet)
                       CUSTNO_: tFloatField;
                       COMPANY_: tStringField;
                       ADDR1_: tStringField;
                       ADDR2_: tStringField;
                       CITY_: tStringField;
                       STATE_: tStringField;
                       ZIP_: tStringField;
                       COUNTRY_: tStringField;
                       PHONE_: tStringField;
                       FAX_: tStringField;
                       TAXRATE_: tFloatField;
                       CONTACT_: tStringField;
                       LASTINVOICEDATE_: tDateTimeField;
                     
                       constructor create_customer(p_c_owner: tComponent;
                           p_c_ib_database: tIbDatabase; p_select_sql: String);
                       procedure open_dataset();
                     
                       procedure after_open(p_c_dataset: tDataset);
                     
                       procedure before_edit(p_c_dataset: tDataset);
                       procedure before_post(p_c_dataset: tDataset);
                     
                       procedure custno_validate(p_c_field: tField);
                     end; // c_customer
  
  implementation
    uses u_dm_database;
    
    // -- c_customer
    
    Constructor c_customer.create_customer(p_c_owner: tComponent;
        p_c_ib_database: tIbDatabase; p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        DataBase:= p_c_ib_database;
        SelectSql.Text:= p_select_sql;
        ModifySql.Text:= 'UPDATE customer'
            + '  SET'
            + '    COMPANY= :COMPANY,'
            + '    ADDR1= :ADDR1,'
            + '    ADDR2= :ADDR2,'
            + '    CITY= :CITY,'
            + '    STATE= :STATE,'
            + '    ZIP= :ZIP,'
            + '    COUNTRY= :COUNTRY,'
            + '    PHONE= :PHONE,'
            + '    FAX= :FAX,'
            + '    TAXRATE= :TAXRATE,'
            + '    CONTACT= :CONTACT,'
            + '    LASTINVOICEDATE= :LASTINVOICEDATE'
            + '    WHERE'
            + '      CUSTNO = :OLD_CUSTNO';
        InsertSql.Text:= 'INSERT INTO customer'
            + '    (CUSTNO,COMPANY,ADDR1,ADDR2,CITY,STATE,ZIP,COUNTRY,PHONE,FAX,TAXRATE,CONTACT,LASTINVOICEDATE)'
            + '  VALUES'
            + '    (:CUSTNO,:COMPANY,:ADDR1,:ADDR2,:CITY,:STATE,:ZIP,:COUNTRY,:PHONE,:FAX,:TAXRATE,:CONTACT,:LASTINVOICEDATE)';
        DeleteSql.Text:= 'DELETE FROM customer'
            + '  WHERE'
            + '    CUSTNO = :OLD_CUSTNO';
      
        AfterOpen:= after_open;
        
        // -- hook the events
        BeforeEdit:= before_edit;
        BeforePost:= before_post;
      end; // create_customer
    
    procedure c_customer.open_dataset();
      begin
        Open;
      end; // open_dataset
    
    procedure c_customer.after_open(p_c_dataset: tDataset);
      var l_field_index: Integer;
      begin
        // -- check which columns are included, and link them to our attributes
        for l_field_index:= 0 to FieldCount- 1 do
          with FieldDefs[l_field_index] do
            if Name= 'CUSTNO'
              then CUSTNO_:= Fields[l_field_index] as tFloatField else
            if Name= 'COMPANY'
              then COMPANY_:= Fields[l_field_index] as tStringField else
            if Name= 'ADDR1'
              then ADDR1_:= Fields[l_field_index] as tStringField else
            if Name= 'ADDR2'
              then ADDR2_:= Fields[l_field_index] as tStringField else
            if Name= 'CITY'
              then CITY_:= Fields[l_field_index] as tStringField else
            if Name= 'STATE'
              then STATE_:= Fields[l_field_index] as tStringField else
            if Name= 'ZIP'
              then ZIP_:= Fields[l_field_index] as tStringField else
            if Name= 'COUNTRY'
              then COUNTRY_:= Fields[l_field_index] as tStringField else
            if Name= 'PHONE'
              then PHONE_:= Fields[l_field_index] as tStringField else
            if Name= 'FAX'
              then FAX_:= Fields[l_field_index] as tStringField else
            if Name= 'TAXRATE'
              then TAXRATE_:= Fields[l_field_index] as tFloatField else
            if Name= 'CONTACT'
              then CONTACT_:= Fields[l_field_index] as tStringField else
            if Name= 'LASTINVOICEDATE'
              then LASTINVOICEDATE_:= Fields[l_field_index] as tDateTimeField else
          
          // -- hook the field_events
          custno_.OnValidate:= custno_validate;
      end; // after_open_dataset
    
    procedure c_customer.before_edit(p_c_dataset: tDataset);
      begin
      end; // before_edit
    
    procedure c_customer.before_post(p_c_dataset: tDataset);
      begin
        // -- get next key
        if State= dsInsert
          then CUSTNO_.Value:= dm_database.f_get_next_key('customer_generator');
      end; // before_post
    
    procedure c_customer.custno_validate(p_c_field: tField);
      begin
      end; // custno_validate
  
  end.
