// 001 u_c_customer_module
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_customer_module;
  interface
    uses Classes, Db, IBCustomDataSet, u_c_customer;
    
    type c_customer_module= Class(tComponent)
                              _customer: c_customer;
                              _customer_datasource: tDataSource;
                            
                              constructor create_customer_module(p_c_owner: tComponent;
                                p_select_sql: String);
                              procedure _open_dataset();
                              procedure _close_dataset();
                            end; // c_customer_module
  
  implementation
      uses u_dm_database;
    
    // -- c_customer_module
    
    Constructor c_customer_module.create_customer_module(p_c_owner: tComponent;
        p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        _customer:= c_customer.create_customer(Self, dm_database.IbDataBase1, p_select_sql);
        
        // -- create and link a datasource
        _customer_datasource:= tDataSource.Create(Self);
        _customer_datasource.DataSet:= _customer;
      end; // create_customer_module
    
    procedure c_customer_module._open_dataset();
      begin
        _customer.open_dataset();
      end; // _open_dataset
    
    procedure c_customer_module._close_dataset();
      begin
        _customer.Close();
      end; // _close_dataset
  
  end.
