// 001 u_c_employee
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_employee;
  interface
    uses Classes, Db, IbDatabase, IBCustomDataSet;
    
    type c_employee= Class(tIbDataSet)
                       EMPNO_: tIntegerField;
                       LASTNAME_: tStringField;
                       FIRSTNAME_: tStringField;
                       PHONEEXT_: tStringField;
                       HIREDATE_: tDateTimeField;
                       SALARY_: tFloatField;
                     
                       constructor create_employee(p_c_owner: tComponent;
                           p_c_ib_database: tIbDatabase; p_select_sql: String);
                       procedure open_dataset();
                     
                       procedure after_open(p_c_dataset: tDataset);
                     
                       procedure before_edit(p_c_dataset: tDataset);
                       procedure before_post(p_c_dataset: tDataset);
                     
                       procedure empno_validate(p_c_field: tField);
                     end; // c_employee
  
  implementation
    uses u_dm_database;
    
    // -- c_employee
    
    Constructor c_employee.create_employee(p_c_owner: tComponent;
        p_c_ib_database: tIbDatabase; p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        DataBase:= p_c_ib_database;
        SelectSql.Text:= p_select_sql;
        ModifySql.Text:= 'UPDATE employee'
            + '  SET'
            + '    LASTNAME= :LASTNAME,'
            + '    FIRSTNAME= :FIRSTNAME,'
            + '    PHONEEXT= :PHONEEXT,'
            + '    HIREDATE= :HIREDATE,'
            + '    SALARY= :SALARY'
            + '    WHERE'
            + '      EMPNO = :OLD_EMPNO';
        InsertSql.Text:= 'INSERT INTO employee'
            + '    (EMPNO,LASTNAME,FIRSTNAME,PHONEEXT,HIREDATE,SALARY)'
            + '  VALUES'
            + '    (:EMPNO,:LASTNAME,:FIRSTNAME,:PHONEEXT,:HIREDATE,:SALARY)';
        DeleteSql.Text:= 'DELETE FROM employee'
            + '  WHERE'
            + '    EMPNO = :OLD_EMPNO';
      
        AfterOpen:= after_open;
        
        // -- hook the events
        BeforeEdit:= before_edit;
        BeforePost:= before_post;
      end; // create_employee
    
    procedure c_employee.open_dataset();
      begin
        Open;
      end; // open_dataset
    
    procedure c_employee.after_open(p_c_dataset: tDataset);
      var l_field_index: Integer;
      begin
        // -- check which columns are included, and link them to our attributes
        for l_field_index:= 0 to FieldCount- 1 do
          with FieldDefs[l_field_index] do
            if Name= 'EMPNO'
              then EMPNO_:= Fields[l_field_index] as tIntegerField else
            if Name= 'LASTNAME'
              then LASTNAME_:= Fields[l_field_index] as tStringField else
            if Name= 'FIRSTNAME'
              then FIRSTNAME_:= Fields[l_field_index] as tStringField else
            if Name= 'PHONEEXT'
              then PHONEEXT_:= Fields[l_field_index] as tStringField else
            if Name= 'HIREDATE'
              then HIREDATE_:= Fields[l_field_index] as tDateTimeField else
            if Name= 'SALARY'
              then SALARY_:= Fields[l_field_index] as tFloatField else
          
          // -- hook the field_events
          empno_.OnValidate:= empno_validate;
      end; // after_open_dataset
    
    procedure c_employee.before_edit(p_c_dataset: tDataset);
      begin
      end; // before_edit
    
    procedure c_employee.before_post(p_c_dataset: tDataset);
      begin
        // -- get next key
        if State= dsInsert
          then EMPNO_.Value:= dm_database.f_get_next_key('employee_generator');
      end; // before_post
    
    procedure c_employee.empno_validate(p_c_field: tField);
      begin
      end; // empno_validate
  
  end.
