// 001 u_c_employee_module
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_employee_module;
  interface
    uses Classes, Db, IBCustomDataSet, u_c_employee;
    
    type c_employee_module= Class(tComponent)
                              _employee: c_employee;
                              _employee_datasource: tDataSource;
                            
                              constructor create_employee_module(p_c_owner: tComponent;
                                p_select_sql: String);
                              procedure _open_dataset();
                              procedure _close_dataset();
                            end; // c_employee_module
  
  implementation
      uses u_dm_database;
    
    // -- c_employee_module
    
    Constructor c_employee_module.create_employee_module(p_c_owner: tComponent;
        p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        _employee:= c_employee.create_employee(Self, dm_database.IbDataBase1, p_select_sql);
        
        // -- create and link a datasource
        _employee_datasource:= tDataSource.Create(Self);
        _employee_datasource.DataSet:= _employee;
      end; // create_employee_module
    
    procedure c_employee_module._open_dataset();
      begin
        _employee.open_dataset();
      end; // _open_dataset
    
    procedure c_employee_module._close_dataset();
      begin
        _employee.Close();
      end; // _close_dataset
  
  end.
