// 001 u_c_items
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_items;
  interface
    uses Classes, Db, IbDatabase, IBCustomDataSet;
    
    type c_items= Class(tIbDataSet)
                    ITEMNO_: tFloatField;
                    ORDERNO_: tFloatField;
                    PARTNO_: tFloatField;
                    QTY_: tIntegerField;
                    DISCOUNT_: tFloatField;
                  
                    constructor create_items(p_c_owner: tComponent;
                        p_c_ib_database: tIbDatabase; p_select_sql: String);
                    procedure open_dataset();
                  
                    procedure after_open(p_c_dataset: tDataset);
                  
                    procedure before_edit(p_c_dataset: tDataset);
                    procedure before_post(p_c_dataset: tDataset);
                  
                    procedure itemno_validate(p_c_field: tField);
                  end; // c_items
  
  implementation
    uses u_dm_database;
    
    // -- c_items
    
    Constructor c_items.create_items(p_c_owner: tComponent;
        p_c_ib_database: tIbDatabase; p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        DataBase:= p_c_ib_database;
        SelectSql.Text:= p_select_sql;
        ModifySql.Text:= 'UPDATE items'
            + '  SET'
            + '    ORDERNO= :ORDERNO,'
            + '    PARTNO= :PARTNO,'
            + '    QTY= :QTY,'
            + '    DISCOUNT= :DISCOUNT'
            + '    WHERE'
            + '      ITEMNO = :OLD_ITEMNO';
        InsertSql.Text:= 'INSERT INTO items'
            + '    (ITEMNO,ORDERNO,PARTNO,QTY,DISCOUNT)'
            + '  VALUES'
            + '    (:ITEMNO,:ORDERNO,:PARTNO,:QTY,:DISCOUNT)';
        DeleteSql.Text:= 'DELETE FROM items'
            + '  WHERE'
            + '    ITEMNO = :OLD_ITEMNO';
      
        AfterOpen:= after_open;
        
        // -- hook the events
        BeforeEdit:= before_edit;
        BeforePost:= before_post;
      end; // create_items
    
    procedure c_items.open_dataset();
      begin
        Open;
      end; // open_dataset
    
    procedure c_items.after_open(p_c_dataset: tDataset);
      var l_field_index: Integer;
      begin
        // -- check which columns are included, and link them to our attributes
        for l_field_index:= 0 to FieldCount- 1 do
          with FieldDefs[l_field_index] do
            if Name= 'ITEMNO'
              then ITEMNO_:= Fields[l_field_index] as tFloatField else
            if Name= 'ORDERNO'
              then ORDERNO_:= Fields[l_field_index] as tFloatField else
            if Name= 'PARTNO'
              then PARTNO_:= Fields[l_field_index] as tFloatField else
            if Name= 'QTY'
              then QTY_:= Fields[l_field_index] as tIntegerField else
            if Name= 'DISCOUNT'
              then DISCOUNT_:= Fields[l_field_index] as tFloatField else
          
          // -- hook the field_events
          itemno_.OnValidate:= itemno_validate;
      end; // after_open_dataset
    
    procedure c_items.before_edit(p_c_dataset: tDataset);
      begin
      end; // before_edit
    
    procedure c_items.before_post(p_c_dataset: tDataset);
      begin
        // -- get next key
        if State= dsInsert
          then ITEMNO_.Value:= dm_database.f_get_next_key('items_generator');
      end; // before_post
    
    procedure c_items.itemno_validate(p_c_field: tField);
      begin
      end; // itemno_validate
  
  end.
