// 001 u_c_items_module
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_items_module;
  interface
    uses Classes, Db, IBCustomDataSet, u_c_items;
    
    type c_items_module= Class(tComponent)
                           _items: c_items;
                           _items_datasource: tDataSource;
                         
                           constructor create_items_module(p_c_owner: tComponent;
                             p_select_sql: String);
                           procedure _open_dataset();
                           procedure _close_dataset();
                         end; // c_items_module
  
  implementation
      uses u_dm_database;
    
    // -- c_items_module
    
    Constructor c_items_module.create_items_module(p_c_owner: tComponent;
        p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        _items:= c_items.create_items(Self, dm_database.IbDataBase1, p_select_sql);
        
        // -- create and link a datasource
        _items_datasource:= tDataSource.Create(Self);
        _items_datasource.DataSet:= _items;
      end; // create_items_module
    
    procedure c_items_module._open_dataset();
      begin
        _items.open_dataset();
      end; // _open_dataset
    
    procedure c_items_module._close_dataset();
      begin
        _items.Close();
      end; // _close_dataset
  
  end.
