// 001 u_c_nextcust
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_nextcust;
  interface
    uses Classes, Db, IbDatabase, IBCustomDataSet;
    
    type c_nextcust= Class(tIbDataSet)
                       NEWCUST_: tFloatField;
                     
                       constructor create_nextcust(p_c_owner: tComponent;
                           p_c_ib_database: tIbDatabase; p_select_sql: String);
                       procedure open_dataset();
                     
                       procedure after_open(p_c_dataset: tDataset);
                     
                       procedure before_edit(p_c_dataset: tDataset);
                       procedure before_post(p_c_dataset: tDataset);
                     
                       procedure newcust_validate(p_c_field: tField);
                     end; // c_nextcust
  
  implementation
    uses u_dm_database;
    
    // -- c_nextcust
    
    Constructor c_nextcust.create_nextcust(p_c_owner: tComponent;
        p_c_ib_database: tIbDatabase; p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        DataBase:= p_c_ib_database;
        SelectSql.Text:= p_select_sql;
        ModifySql.Text:= 'UPDATE nextcust'
            + '  SET'
            + '    WHERE'
            + '      NEWCUST = :OLD_NEWCUST';
        InsertSql.Text:= 'INSERT INTO nextcust'
            + '    (NEWCUST)'
            + '  VALUES'
            + '    (:NEWCUST)';
        DeleteSql.Text:= 'DELETE FROM nextcust'
            + '  WHERE'
            + '    NEWCUST = :OLD_NEWCUST';
      
        AfterOpen:= after_open;
        
        // -- hook the events
        BeforeEdit:= before_edit;
        BeforePost:= before_post;
      end; // create_nextcust
    
    procedure c_nextcust.open_dataset();
      begin
        Open;
      end; // open_dataset
    
    procedure c_nextcust.after_open(p_c_dataset: tDataset);
      var l_field_index: Integer;
      begin
        // -- check which columns are included, and link them to our attributes
        for l_field_index:= 0 to FieldCount- 1 do
          with FieldDefs[l_field_index] do
            if Name= 'NEWCUST'
              then NEWCUST_:= Fields[l_field_index] as tFloatField else
          
          // -- hook the field_events
          newcust_.OnValidate:= newcust_validate;
      end; // after_open_dataset
    
    procedure c_nextcust.before_edit(p_c_dataset: tDataset);
      begin
      end; // before_edit
    
    procedure c_nextcust.before_post(p_c_dataset: tDataset);
      begin
        // -- get next key
        if State= dsInsert
          then NEWCUST_.Value:= dm_database.f_get_next_key('nextcust_generator');
      end; // before_post
    
    procedure c_nextcust.newcust_validate(p_c_field: tField);
      begin
      end; // newcust_validate
  
  end.
