// 001 u_c_nextord
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_nextord;
  interface
    uses Classes, Db, IbDatabase, IBCustomDataSet;
    
    type c_nextord= Class(tIbDataSet)
                      NEWKEY_: tFloatField;
                    
                      constructor create_nextord(p_c_owner: tComponent;
                          p_c_ib_database: tIbDatabase; p_select_sql: String);
                      procedure open_dataset();
                    
                      procedure after_open(p_c_dataset: tDataset);
                    
                      procedure before_edit(p_c_dataset: tDataset);
                      procedure before_post(p_c_dataset: tDataset);
                    
                      procedure newkey_validate(p_c_field: tField);
                    end; // c_nextord
  
  implementation
    uses u_dm_database;
    
    // -- c_nextord
    
    Constructor c_nextord.create_nextord(p_c_owner: tComponent;
        p_c_ib_database: tIbDatabase; p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        DataBase:= p_c_ib_database;
        SelectSql.Text:= p_select_sql;
        ModifySql.Text:= 'UPDATE nextord'
            + '  SET'
            + '    WHERE'
            + '      NEWKEY = :OLD_NEWKEY';
        InsertSql.Text:= 'INSERT INTO nextord'
            + '    (NEWKEY)'
            + '  VALUES'
            + '    (:NEWKEY)';
        DeleteSql.Text:= 'DELETE FROM nextord'
            + '  WHERE'
            + '    NEWKEY = :OLD_NEWKEY';
      
        AfterOpen:= after_open;
        
        // -- hook the events
        BeforeEdit:= before_edit;
        BeforePost:= before_post;
      end; // create_nextord
    
    procedure c_nextord.open_dataset();
      begin
        Open;
      end; // open_dataset
    
    procedure c_nextord.after_open(p_c_dataset: tDataset);
      var l_field_index: Integer;
      begin
        // -- check which columns are included, and link them to our attributes
        for l_field_index:= 0 to FieldCount- 1 do
          with FieldDefs[l_field_index] do
            if Name= 'NEWKEY'
              then NEWKEY_:= Fields[l_field_index] as tFloatField else
          
          // -- hook the field_events
          newkey_.OnValidate:= newkey_validate;
      end; // after_open_dataset
    
    procedure c_nextord.before_edit(p_c_dataset: tDataset);
      begin
      end; // before_edit
    
    procedure c_nextord.before_post(p_c_dataset: tDataset);
      begin
        // -- get next key
        if State= dsInsert
          then NEWKEY_.Value:= dm_database.f_get_next_key('nextord_generator');
      end; // before_post
    
    procedure c_nextord.newkey_validate(p_c_field: tField);
      begin
      end; // newkey_validate
  
  end.
