// 001 u_c_orders
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_orders;
  interface
    uses Classes, Db, IbDatabase, IBCustomDataSet;
    
    type c_orders= Class(tIbDataSet)
                     ORDERNO_: tFloatField;
                     CUSTNO_: tFloatField;
                     SALEDATE_: tDateTimeField;
                     SHIPDATE_: tDateTimeField;
                     EMPNO_: tIntegerField;
                     SHIPTOCONTACT_: tStringField;
                     SHIPTOADDR1_: tStringField;
                     SHIPTOADDR2_: tStringField;
                     SHIPTOCITY_: tStringField;
                     SHIPTOSTATE_: tStringField;
                     SHIPTOZIP_: tStringField;
                     SHIPTOCOUNTRY_: tStringField;
                     SHIPTOPHONE_: tStringField;
                     SHIPVIA_: tStringField;
                     PO_: tStringField;
                     TERMS_: tStringField;
                     PAYMENTMETHOD_: tStringField;
                     ITEMSTOTAL_: tFloatField;
                     TAXRATE_: tFloatField;
                     FREIGHT_: tFloatField;
                     AMOUNTPAID_: tFloatField;
                   
                     constructor create_orders(p_c_owner: tComponent;
                         p_c_ib_database: tIbDatabase; p_select_sql: String);
                     procedure open_dataset();
                   
                     procedure after_open(p_c_dataset: tDataset);
                   
                     procedure before_edit(p_c_dataset: tDataset);
                     procedure before_post(p_c_dataset: tDataset);
                   
                     procedure orderno_validate(p_c_field: tField);
                   end; // c_orders
  
  implementation
    uses u_dm_database;
    
    // -- c_orders
    
    Constructor c_orders.create_orders(p_c_owner: tComponent;
        p_c_ib_database: tIbDatabase; p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        DataBase:= p_c_ib_database;
        SelectSql.Text:= p_select_sql;
        ModifySql.Text:= 'UPDATE orders'
            + '  SET'
            + '    CUSTNO= :CUSTNO,'
            + '    SALEDATE= :SALEDATE,'
            + '    SHIPDATE= :SHIPDATE,'
            + '    EMPNO= :EMPNO,'
            + '    SHIPTOCONTACT= :SHIPTOCONTACT,'
            + '    SHIPTOADDR1= :SHIPTOADDR1,'
            + '    SHIPTOADDR2= :SHIPTOADDR2,'
            + '    SHIPTOCITY= :SHIPTOCITY,'
            + '    SHIPTOSTATE= :SHIPTOSTATE,'
            + '    SHIPTOZIP= :SHIPTOZIP,'
            + '    SHIPTOCOUNTRY= :SHIPTOCOUNTRY,'
            + '    SHIPTOPHONE= :SHIPTOPHONE,'
            + '    SHIPVIA= :SHIPVIA,'
            + '    PO= :PO,'
            + '    TERMS= :TERMS,'
            + '    PAYMENTMETHOD= :PAYMENTMETHOD,'
            + '    ITEMSTOTAL= :ITEMSTOTAL,'
            + '    TAXRATE= :TAXRATE,'
            + '    FREIGHT= :FREIGHT,'
            + '    AMOUNTPAID= :AMOUNTPAID'
            + '    WHERE'
            + '      ORDERNO = :OLD_ORDERNO';
        InsertSql.Text:= 'INSERT INTO orders'
            + '    (ORDERNO,CUSTNO,SALEDATE,SHIPDATE,EMPNO,SHIPTOCONTACT,SHIPTOADDR1,SHIPTOADDR2,SHIPTOCITY,SHIPTOSTATE,SHIPTOZIP,SHIPTOCOUNTRY,SHIPTOPHONE,SHIPVIA,PO,TERMS,PAYMENTMETHOD,ITEMSTOTAL,TAXRATE,FREIGHT,AMOUNTPAID)'
            + '  VALUES'
            + '    (:ORDERNO,:CUSTNO,:SALEDATE,:SHIPDATE,:EMPNO,:SHIPTOCONTACT,:SHIPTOADDR1,:SHIPTOADDR2,:SHIPTOCITY,:SHIPTOSTATE,:SHIPTOZIP,:SHIPTOCOUNTRY,:SHIPTOPHONE,:SHIPVIA,:PO,:TERMS,:PAYMENTMETHOD,:ITEMSTOTAL,:TAXRATE,:FREIGHT,:AMOUNTPAID)';
        DeleteSql.Text:= 'DELETE FROM orders'
            + '  WHERE'
            + '    ORDERNO = :OLD_ORDERNO';
      
        AfterOpen:= after_open;
        
        // -- hook the events
        BeforeEdit:= before_edit;
        BeforePost:= before_post;
      end; // create_orders
    
    procedure c_orders.open_dataset();
      begin
        Open;
      end; // open_dataset
    
    procedure c_orders.after_open(p_c_dataset: tDataset);
      var l_field_index: Integer;
      begin
        // -- check which columns are included, and link them to our attributes
        for l_field_index:= 0 to FieldCount- 1 do
          with FieldDefs[l_field_index] do
            if Name= 'ORDERNO'
              then ORDERNO_:= Fields[l_field_index] as tFloatField else
            if Name= 'CUSTNO'
              then CUSTNO_:= Fields[l_field_index] as tFloatField else
            if Name= 'SALEDATE'
              then SALEDATE_:= Fields[l_field_index] as tDateTimeField else
            if Name= 'SHIPDATE'
              then SHIPDATE_:= Fields[l_field_index] as tDateTimeField else
            if Name= 'EMPNO'
              then EMPNO_:= Fields[l_field_index] as tIntegerField else
            if Name= 'SHIPTOCONTACT'
              then SHIPTOCONTACT_:= Fields[l_field_index] as tStringField else
            if Name= 'SHIPTOADDR1'
              then SHIPTOADDR1_:= Fields[l_field_index] as tStringField else
            if Name= 'SHIPTOADDR2'
              then SHIPTOADDR2_:= Fields[l_field_index] as tStringField else
            if Name= 'SHIPTOCITY'
              then SHIPTOCITY_:= Fields[l_field_index] as tStringField else
            if Name= 'SHIPTOSTATE'
              then SHIPTOSTATE_:= Fields[l_field_index] as tStringField else
            if Name= 'SHIPTOZIP'
              then SHIPTOZIP_:= Fields[l_field_index] as tStringField else
            if Name= 'SHIPTOCOUNTRY'
              then SHIPTOCOUNTRY_:= Fields[l_field_index] as tStringField else
            if Name= 'SHIPTOPHONE'
              then SHIPTOPHONE_:= Fields[l_field_index] as tStringField else
            if Name= 'SHIPVIA'
              then SHIPVIA_:= Fields[l_field_index] as tStringField else
            if Name= 'PO'
              then PO_:= Fields[l_field_index] as tStringField else
            if Name= 'TERMS'
              then TERMS_:= Fields[l_field_index] as tStringField else
            if Name= 'PAYMENTMETHOD'
              then PAYMENTMETHOD_:= Fields[l_field_index] as tStringField else
            if Name= 'ITEMSTOTAL'
              then ITEMSTOTAL_:= Fields[l_field_index] as tFloatField else
            if Name= 'TAXRATE'
              then TAXRATE_:= Fields[l_field_index] as tFloatField else
            if Name= 'FREIGHT'
              then FREIGHT_:= Fields[l_field_index] as tFloatField else
            if Name= 'AMOUNTPAID'
              then AMOUNTPAID_:= Fields[l_field_index] as tFloatField else
          
          // -- hook the field_events
          orderno_.OnValidate:= orderno_validate;
      end; // after_open_dataset
    
    procedure c_orders.before_edit(p_c_dataset: tDataset);
      begin
      end; // before_edit
    
    procedure c_orders.before_post(p_c_dataset: tDataset);
      begin
        // -- get next key
        if State= dsInsert
          then ORDERNO_.Value:= dm_database.f_get_next_key('orders_generator');
      end; // before_post
    
    procedure c_orders.orderno_validate(p_c_field: tField);
      begin
      end; // orderno_validate
  
  end.
