// 001 u_c_orders_module
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_orders_module;
  interface
    uses Classes, Db, IBCustomDataSet, u_c_orders;
    
    type c_orders_module= Class(tComponent)
                            _orders: c_orders;
                            _orders_datasource: tDataSource;
                          
                            constructor create_orders_module(p_c_owner: tComponent;
                              p_select_sql: String);
                            procedure _open_dataset();
                            procedure _close_dataset();
                          end; // c_orders_module
  
  implementation
      uses u_dm_database;
    
    // -- c_orders_module
    
    Constructor c_orders_module.create_orders_module(p_c_owner: tComponent;
        p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        _orders:= c_orders.create_orders(Self, dm_database.IbDataBase1, p_select_sql);
        
        // -- create and link a datasource
        _orders_datasource:= tDataSource.Create(Self);
        _orders_datasource.DataSet:= _orders;
      end; // create_orders_module
    
    procedure c_orders_module._open_dataset();
      begin
        _orders.open_dataset();
      end; // _open_dataset
    
    procedure c_orders_module._close_dataset();
      begin
        _orders.Close();
      end; // _close_dataset
  
  end.
