// 001 u_c_parts
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_parts;
  interface
    uses Classes, Db, IbDatabase, IBCustomDataSet;
    
    type c_parts= Class(tIbDataSet)
                    PARTNO_: tFloatField;
                    VENDORNO_: tFloatField;
                    DESCRIPTION_: tStringField;
                    ONHAND_: tFloatField;
                    ONORDER_: tFloatField;
                    COST_: tFloatField;
                    LISTPRICE_: tFloatField;
                  
                    constructor create_parts(p_c_owner: tComponent;
                        p_c_ib_database: tIbDatabase; p_select_sql: String);
                    procedure open_dataset();
                  
                    procedure after_open(p_c_dataset: tDataset);
                  
                    procedure before_edit(p_c_dataset: tDataset);
                    procedure before_post(p_c_dataset: tDataset);
                  
                    procedure partno_validate(p_c_field: tField);
                  end; // c_parts
  
  implementation
    uses u_dm_database;
    
    // -- c_parts
    
    Constructor c_parts.create_parts(p_c_owner: tComponent;
        p_c_ib_database: tIbDatabase; p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        DataBase:= p_c_ib_database;
        SelectSql.Text:= p_select_sql;
        ModifySql.Text:= 'UPDATE parts'
            + '  SET'
            + '    VENDORNO= :VENDORNO,'
            + '    DESCRIPTION= :DESCRIPTION,'
            + '    ONHAND= :ONHAND,'
            + '    ONORDER= :ONORDER,'
            + '    COST= :COST,'
            + '    LISTPRICE= :LISTPRICE'
            + '    WHERE'
            + '      PARTNO = :OLD_PARTNO';
        InsertSql.Text:= 'INSERT INTO parts'
            + '    (PARTNO,VENDORNO,DESCRIPTION,ONHAND,ONORDER,COST,LISTPRICE)'
            + '  VALUES'
            + '    (:PARTNO,:VENDORNO,:DESCRIPTION,:ONHAND,:ONORDER,:COST,:LISTPRICE)';
        DeleteSql.Text:= 'DELETE FROM parts'
            + '  WHERE'
            + '    PARTNO = :OLD_PARTNO';
      
        AfterOpen:= after_open;
        
        // -- hook the events
        BeforeEdit:= before_edit;
        BeforePost:= before_post;
      end; // create_parts
    
    procedure c_parts.open_dataset();
      begin
        Open;
      end; // open_dataset
    
    procedure c_parts.after_open(p_c_dataset: tDataset);
      var l_field_index: Integer;
      begin
        // -- check which columns are included, and link them to our attributes
        for l_field_index:= 0 to FieldCount- 1 do
          with FieldDefs[l_field_index] do
            if Name= 'PARTNO'
              then PARTNO_:= Fields[l_field_index] as tFloatField else
            if Name= 'VENDORNO'
              then VENDORNO_:= Fields[l_field_index] as tFloatField else
            if Name= 'DESCRIPTION'
              then DESCRIPTION_:= Fields[l_field_index] as tStringField else
            if Name= 'ONHAND'
              then ONHAND_:= Fields[l_field_index] as tFloatField else
            if Name= 'ONORDER'
              then ONORDER_:= Fields[l_field_index] as tFloatField else
            if Name= 'COST'
              then COST_:= Fields[l_field_index] as tFloatField else
            if Name= 'LISTPRICE'
              then LISTPRICE_:= Fields[l_field_index] as tFloatField else
          
          // -- hook the field_events
          partno_.OnValidate:= partno_validate;
      end; // after_open_dataset
    
    procedure c_parts.before_edit(p_c_dataset: tDataset);
      begin
      end; // before_edit
    
    procedure c_parts.before_post(p_c_dataset: tDataset);
      begin
        // -- get next key
        if State= dsInsert
          then PARTNO_.Value:= dm_database.f_get_next_key('parts_generator');
      end; // before_post
    
    procedure c_parts.partno_validate(p_c_field: tField);
      begin
      end; // partno_validate
  
  end.
