// 001 u_c_parts_module
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_parts_module;
  interface
    uses Classes, Db, IBCustomDataSet, u_c_parts;
    
    type c_parts_module= Class(tComponent)
                           _parts: c_parts;
                           _parts_datasource: tDataSource;
                         
                           constructor create_parts_module(p_c_owner: tComponent;
                             p_select_sql: String);
                           procedure _open_dataset();
                           procedure _close_dataset();
                         end; // c_parts_module
  
  implementation
      uses u_dm_database;
    
    // -- c_parts_module
    
    Constructor c_parts_module.create_parts_module(p_c_owner: tComponent;
        p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        _parts:= c_parts.create_parts(Self, dm_database.IbDataBase1, p_select_sql);
        
        // -- create and link a datasource
        _parts_datasource:= tDataSource.Create(Self);
        _parts_datasource.DataSet:= _parts;
      end; // create_parts_module
    
    procedure c_parts_module._open_dataset();
      begin
        _parts.open_dataset();
      end; // _open_dataset
    
    procedure c_parts_module._close_dataset();
      begin
        _parts.Close();
      end; // _close_dataset
  
  end.
