// 001 u_c_vendors
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_vendors;
  interface
    uses Classes, Db, IbDatabase, IBCustomDataSet;
    
    type c_vendors= Class(tIbDataSet)
                      VENDORNO_: tFloatField;
                      VENDORNAME_: tStringField;
                      ADDRESS1_: tStringField;
                      ADDRESS2_: tStringField;
                      CITY_: tStringField;
                      STATE_: tStringField;
                      ZIP_: tStringField;
                      COUNTRY_: tStringField;
                      PHONE_: tStringField;
                      FAX_: tStringField;
                      PREFERRED_: tStringField;
                    
                      constructor create_vendors(p_c_owner: tComponent;
                          p_c_ib_database: tIbDatabase; p_select_sql: String);
                      procedure open_dataset();
                    
                      procedure after_open(p_c_dataset: tDataset);
                    
                      procedure before_edit(p_c_dataset: tDataset);
                      procedure before_post(p_c_dataset: tDataset);
                    
                      procedure vendorno_validate(p_c_field: tField);
                    end; // c_vendors
  
  implementation
    uses u_dm_database;
    
    // -- c_vendors
    
    Constructor c_vendors.create_vendors(p_c_owner: tComponent;
        p_c_ib_database: tIbDatabase; p_select_sql: String);
      begin
        Inherited Create(p_c_owner);
        
        DataBase:= p_c_ib_database;
        SelectSql.Text:= p_select_sql;
        ModifySql.Text:= 'UPDATE vendors'
            + '  SET'
            + '    VENDORNAME= :VENDORNAME,'
            + '    ADDRESS1= :ADDRESS1,'
            + '    ADDRESS2= :ADDRESS2,'
            + '    CITY= :CITY,'
            + '    STATE= :STATE,'
            + '    ZIP= :ZIP,'
            + '    COUNTRY= :COUNTRY,'
            + '    PHONE= :PHONE,'
            + '    FAX= :FAX,'
            + '    PREFERRED= :PREFERRED'
            + '    WHERE'
            + '      VENDORNO = :OLD_VENDORNO';
        InsertSql.Text:= 'INSERT INTO vendors'
            + '    (VENDORNO,VENDORNAME,ADDRESS1,ADDRESS2,CITY,STATE,ZIP,COUNTRY,PHONE,FAX,PREFERRED)'
            + '  VALUES'
            + '    (:VENDORNO,:VENDORNAME,:ADDRESS1,:ADDRESS2,:CITY,:STATE,:ZIP,:COUNTRY,:PHONE,:FAX,:PREFERRED)';
        DeleteSql.Text:= 'DELETE FROM vendors'
            + '  WHERE'
            + '    VENDORNO = :OLD_VENDORNO';
      
        AfterOpen:= after_open;
        
        // -- hook the events
        BeforeEdit:= before_edit;
        BeforePost:= before_post;
      end; // create_vendors
    
    procedure c_vendors.open_dataset();
      begin
        Open;
      end; // open_dataset
    
    procedure c_vendors.after_open(p_c_dataset: tDataset);
      var l_field_index: Integer;
      begin
        // -- check which columns are included, and link them to our attributes
        for l_field_index:= 0 to FieldCount- 1 do
          with FieldDefs[l_field_index] do
            if Name= 'VENDORNO'
              then VENDORNO_:= Fields[l_field_index] as tFloatField else
            if Name= 'VENDORNAME'
              then VENDORNAME_:= Fields[l_field_index] as tStringField else
            if Name= 'ADDRESS1'
              then ADDRESS1_:= Fields[l_field_index] as tStringField else
            if Name= 'ADDRESS2'
              then ADDRESS2_:= Fields[l_field_index] as tStringField else
            if Name= 'CITY'
              then CITY_:= Fields[l_field_index] as tStringField else
            if Name= 'STATE'
              then STATE_:= Fields[l_field_index] as tStringField else
            if Name= 'ZIP'
              then ZIP_:= Fields[l_field_index] as tStringField else
            if Name= 'COUNTRY'
              then COUNTRY_:= Fields[l_field_index] as tStringField else
            if Name= 'PHONE'
              then PHONE_:= Fields[l_field_index] as tStringField else
            if Name= 'FAX'
              then FAX_:= Fields[l_field_index] as tStringField else
            if Name= 'PREFERRED'
              then PREFERRED_:= Fields[l_field_index] as tStringField else
          
          // -- hook the field_events
          vendorno_.OnValidate:= vendorno_validate;
      end; // after_open_dataset
    
    procedure c_vendors.before_edit(p_c_dataset: tDataset);
      begin
      end; // before_edit
    
    procedure c_vendors.before_post(p_c_dataset: tDataset);
      begin
        // -- get next key
        if State= dsInsert
          then VENDORNO_.Value:= dm_database.f_get_next_key('vendors_generator');
      end; // before_post
    
    procedure c_vendors.vendorno_validate(p_c_field: tField);
      begin
      end; // vendorno_validate
  
  end.
