// 002 u_f_edit_employee
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_f_edit_employee;
  interface
    uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms
        , Dialogs, StdCtrls, Mask, ExtCtrls, DBCtrls, Grids, DBGrids, DB, IBCustomDataSet
        , u_c_employee, u_c_employee_module
        ;
        
    type
      Tedit_employee_form= class(TForm)
          DBGrid1: TDBGrid;
          DBNavigator1: TDBNavigator;
          db_EMPNO_edit: TDBEdit;
          procedure FormCreate(Sender: TObject);
        private
        public
          m_c_employee_module: c_employee_module;
          
          // -- references
          employee_e: c_employee;
          
          procedure initialize_local_references;
          procedure link_controls;
          procedure open_dataset;
          procedure close_dataset;
          procedure open_at(p_EMPNO: String);
      end; // Tedit_employee_form
      
    var edit_employee_form: Tedit_employee_form;
    
  implementation
    uses // u_display
        //,
        u_dm_database
        ;
        
    {$R *.dfm}
    
    procedure Tedit_employee_form.FormCreate(Sender: TObject);
      begin
        m_c_employee_module:= c_employee_module.create_employee_module(Self, 'SELECT * FROM employee');
      end; // FormCreate
      
    procedure Tedit_employee_form.initialize_local_references;
      begin
        with m_c_employee_module do
        begin
          employee_e:= _employee;
        end; // with m_c_employee_module
      end; // initialize_local_references
      
    procedure Tedit_employee_form.link_controls;
      begin
        with m_c_employee_module do
        begin
          // -- link all the db_xxx datasources
          db_EMPNO_edit.DataSource:= _employee_datasource;
          
          dbGrid1.DataSource:= _employee_datasource;
          dbNavigator1.DataSource:= _employee_datasource;
        end; // with m_c_employee_module do
      end; // link_controls
      
    procedure Tedit_employee_form.open_dataset;
      begin
        m_c_employee_module._open_dataset();
        initialize_local_references;
        link_controls;
      end; // open_dataset
      
    procedure Tedit_employee_form.close_dataset;
      begin
        employee_e.Close();
      end; // close_dataset
      
    procedure Tedit_employee_form.open_at(p_EMPNO: String);
      begin
        open_dataset();
        employee_e.Locate('EMPNO', p_EMPNO, []);
        ShowModal;
        close_dataset();
      end; // open_at
      
      
  end.
