// 002 u_f_edit_items
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_f_edit_items;
  interface
    uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms
        , Dialogs, StdCtrls, Mask, ExtCtrls, DBCtrls, Grids, DBGrids, DB, IBCustomDataSet
        , u_c_items, u_c_items_module
        ;
        
    type
      Tedit_items_form= class(TForm)
          DBGrid1: TDBGrid;
          DBNavigator1: TDBNavigator;
          db_ITEMNO_edit: TDBEdit;
          procedure FormCreate(Sender: TObject);
        private
        public
          m_c_items_module: c_items_module;
          
          // -- references
          items_e: c_items;
          
          procedure initialize_local_references;
          procedure link_controls;
          procedure open_dataset;
          procedure close_dataset;
          procedure open_at(p_ITEMNO: String);
      end; // Tedit_items_form
      
    var edit_items_form: Tedit_items_form;
    
  implementation
    uses // u_display
        //,
        u_dm_database
        ;
        
    {$R *.dfm}
    
    procedure Tedit_items_form.FormCreate(Sender: TObject);
      begin
        m_c_items_module:= c_items_module.create_items_module(Self, 'SELECT * FROM items');
      end; // FormCreate
      
    procedure Tedit_items_form.initialize_local_references;
      begin
        with m_c_items_module do
        begin
          items_e:= _items;
        end; // with m_c_items_module
      end; // initialize_local_references
      
    procedure Tedit_items_form.link_controls;
      begin
        with m_c_items_module do
        begin
          // -- link all the db_xxx datasources
          db_ITEMNO_edit.DataSource:= _items_datasource;
          
          dbGrid1.DataSource:= _items_datasource;
          dbNavigator1.DataSource:= _items_datasource;
        end; // with m_c_items_module do
      end; // link_controls
      
    procedure Tedit_items_form.open_dataset;
      begin
        m_c_items_module._open_dataset();
        initialize_local_references;
        link_controls;
      end; // open_dataset
      
    procedure Tedit_items_form.close_dataset;
      begin
        items_e.Close();
      end; // close_dataset
      
    procedure Tedit_items_form.open_at(p_ITEMNO: String);
      begin
        open_dataset();
        items_e.Locate('ITEMNO', p_ITEMNO, []);
        ShowModal;
        close_dataset();
      end; // open_at
      
      
  end.
