// 002 u_f_edit_orders
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_f_edit_orders;
  interface
    uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms
        , Dialogs, StdCtrls, Mask, ExtCtrls, DBCtrls, Grids, DBGrids, DB, IBCustomDataSet
        , u_c_orders, u_c_orders_module
        ;
        
    type
      Tedit_orders_form= class(TForm)
          DBGrid1: TDBGrid;
          DBNavigator1: TDBNavigator;
          db_ORDERNO_edit: TDBEdit;
          procedure FormCreate(Sender: TObject);
        private
        public
          m_c_orders_module: c_orders_module;
          
          // -- references
          orders_e: c_orders;
          
          procedure initialize_local_references;
          procedure link_controls;
          procedure open_dataset;
          procedure close_dataset;
          procedure open_at(p_ORDERNO: String);
      end; // Tedit_orders_form
      
    var edit_orders_form: Tedit_orders_form;
    
  implementation
    uses // u_display
        //,
        u_dm_database
        ;
        
    {$R *.dfm}
    
    procedure Tedit_orders_form.FormCreate(Sender: TObject);
      begin
        m_c_orders_module:= c_orders_module.create_orders_module(Self, 'SELECT * FROM orders');
      end; // FormCreate
      
    procedure Tedit_orders_form.initialize_local_references;
      begin
        with m_c_orders_module do
        begin
          orders_e:= _orders;
        end; // with m_c_orders_module
      end; // initialize_local_references
      
    procedure Tedit_orders_form.link_controls;
      begin
        with m_c_orders_module do
        begin
          // -- link all the db_xxx datasources
          db_ORDERNO_edit.DataSource:= _orders_datasource;
          
          dbGrid1.DataSource:= _orders_datasource;
          dbNavigator1.DataSource:= _orders_datasource;
        end; // with m_c_orders_module do
      end; // link_controls
      
    procedure Tedit_orders_form.open_dataset;
      begin
        m_c_orders_module._open_dataset();
        initialize_local_references;
        link_controls;
      end; // open_dataset
      
    procedure Tedit_orders_form.close_dataset;
      begin
        orders_e.Close();
      end; // close_dataset
      
    procedure Tedit_orders_form.open_at(p_ORDERNO: String);
      begin
        open_dataset();
        orders_e.Locate('ORDERNO', p_ORDERNO, []);
        ShowModal;
        close_dataset();
      end; // open_at
      
      
  end.
