// 002 u_f_edit_parts
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_f_edit_parts;
  interface
    uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms
        , Dialogs, StdCtrls, Mask, ExtCtrls, DBCtrls, Grids, DBGrids, DB, IBCustomDataSet
        , u_c_parts, u_c_parts_module
        ;
        
    type
      Tedit_parts_form= class(TForm)
          DBGrid1: TDBGrid;
          DBNavigator1: TDBNavigator;
          db_PARTNO_edit: TDBEdit;
          procedure FormCreate(Sender: TObject);
        private
        public
          m_c_parts_module: c_parts_module;
          
          // -- references
          parts_e: c_parts;
          
          procedure initialize_local_references;
          procedure link_controls;
          procedure open_dataset;
          procedure close_dataset;
          procedure open_at(p_PARTNO: String);
      end; // Tedit_parts_form
      
    var edit_parts_form: Tedit_parts_form;
    
  implementation
    uses // u_display
        //,
        u_dm_database
        ;
        
    {$R *.dfm}
    
    procedure Tedit_parts_form.FormCreate(Sender: TObject);
      begin
        m_c_parts_module:= c_parts_module.create_parts_module(Self, 'SELECT * FROM parts');
      end; // FormCreate
      
    procedure Tedit_parts_form.initialize_local_references;
      begin
        with m_c_parts_module do
        begin
          parts_e:= _parts;
        end; // with m_c_parts_module
      end; // initialize_local_references
      
    procedure Tedit_parts_form.link_controls;
      begin
        with m_c_parts_module do
        begin
          // -- link all the db_xxx datasources
          db_PARTNO_edit.DataSource:= _parts_datasource;
          
          dbGrid1.DataSource:= _parts_datasource;
          dbNavigator1.DataSource:= _parts_datasource;
        end; // with m_c_parts_module do
      end; // link_controls
      
    procedure Tedit_parts_form.open_dataset;
      begin
        m_c_parts_module._open_dataset();
        initialize_local_references;
        link_controls;
      end; // open_dataset
      
    procedure Tedit_parts_form.close_dataset;
      begin
        parts_e.Close();
      end; // close_dataset
      
    procedure Tedit_parts_form.open_at(p_PARTNO: String);
      begin
        open_dataset();
        parts_e.Locate('PARTNO', p_PARTNO, []);
        ShowModal;
        close_dataset();
      end; // open_at
      
      
  end.
